/**
 *
 *  Betterville Item Shop Dress
 *  @author Drakkos
 *  @started 31/03/2009
 *
 */

inherit "/obj/clothing";

// The variable for this dress.
string motif;

void setup() {
  set_name ("dress");
  set_short ("beautiful blue dress");
  add_adjective (({"beautiful", "blue"}));
  set_main_plural ("beautiful blue dresses");
  set_long ("This is a beautiful dress, fit for a princess.  It is made "
    "from blue silk and billows around the wearer as if they had some "
    "kind of heating grate at their feet.\n");
  set_weight (8);
  set_value (30000);
  setup_clothing (2000);
  set_damage_chance (30);
  set_material ("silk");
  set_colour ("blue");
  set_type ("long dress");

  add_extra_look (this_object());
}

void set_motif (string m) {
  motif = m;
}

string query_motif() {
  return motif;
}

string extra_look (object ob) {
  if (query_motif()) {
    return "The dress has a motif of " + query_motif() + " stitched "
      "onto it.\n";
  }
  return "";
}

// This method gets called on our object when it gets saved at any 
// point.
mapping query_dynamic_auto_load() {
  mapping map;
  
  // Get the value of the mapping as per the parent class.
  map = ::query_dynamic_auto_load();
  // Add the state information relevant to this object to the 
  // mapping.
  map = add_auto_load_value(map, "beautiful dress", "motif", query_motif());

  // Return the mapping.
  return map;
}

void init_dynamic_arg( mapping map, object ob) {
  string tmp;
    
  // Pass this mapping on to the parent class for it to handle 
  // its own restoration of state.
  ::init_dynamic_arg (map, ob);
  
  // Get whatever is stored in the motif for the mapping.
  tmp = query_auto_load_value (map, "beautiful dress", "motif");
  // Set the motif appropriately.
  set_motif (tmp);
}
